OGRE: Ogre::TerrainPaging Class Reference - OGRE Documentation

Classes | Public Member Functions | Protected Attributes

# Ogre::TerrainPaging Class Reference
[Terrain]

This class is the 'core' class for paging terrain, that will integrate with the larger paging system and provide the appropriate utility classes required. More...

`#include <OgreTerrainPaging.h>`

Inheritance diagram for Ogre::TerrainPaging:
[legend]

List of all members.

## Classes
class | SectionFactory
## Public Member Functions
| TerrainPaging (PageManager *pageMgr)
| Constructor.
| ~TerrainPaging ()
TerrainPagedWorldSection * | createWorldSection (PagedWorld *world, TerrainGroup *terrainGroup, Real loadRadius, Real holdRadius, int32 minX=-10, int32 minY=-10, int32 maxX=10, int32 maxY=10, const String &sectionName=StringUtil::BLANK)
| Create a TerrainPagedWorldSection.
void * | operator new (size_t sz, const char *file, int line, const char *func)
| operator new, with debug line info
void * | operator new (size_t sz)
void * | operator new (size_t sz, void *ptr)
| placement operator new
void * | operator new[] (size_t sz, const char *file, int line, const char *func)
| array operator new, with debug line info
void * | operator new[] (size_t sz)
void | operator delete (void *ptr)
void | operator delete (void *ptr, void *)
void | operator delete (void *ptr, const char *, int, const char *)
void | operator delete[] (void *ptr)
void | operator delete[] (void *ptr, const char *, int, const char *)
## Protected Attributes
PageManager * | mManager
SectionFactory | mSectionFactory

## Detailed Description

This class is the 'core' class for paging terrain, that will integrate with the larger paging system and provide the appropriate utility classes required.

Remarks:
  You should construct this class after PageManager and before any PagedWorlds that might use it are created / loaded. Once constructed, it will make the "Terrain" PagedWorldSection type available, which uses a grid strategy for paging and uses TerrainGroup for the content. Other content can be embedded in the pages too but the terrain is done like this in order to maintain connections between pages and other global data.

  Because PagedWorld and all attached classes have to be loadable from a stream, most of the functionality is provided behind generalised interfaces. However, for constructing a paged terrain in code you can use utility methods on this class. This procedurally created data can then be saved in a generic form which will reconstruct on loading. Alternatively you can use the generic methods and simply cast based on your prior knowledge of the types (or checking the type names exposed).

Definition at line 72 of file OgreTerrainPaging.h.

## Constructor & Destructor Documentation

Ogre::TerrainPaging::TerrainPaging | ( | PageManager * | pageMgr | ) |

Constructor.

Parameters:

  | pageMgr | The PageManager which this class should attach to.

Ogre::TerrainPaging::~TerrainPaging | ( |  | ) |

## Member Function Documentation

TerrainPagedWorldSection* Ogre::TerrainPaging::createWorldSection | ( | PagedWorld * | world,
|  | TerrainGroup * | terrainGroup,
|  | Real | loadRadius,
|  | Real | holdRadius,
|  | int32 | minX = `-10`,
|  | int32 | minY = `-10`,
|  | int32 | maxX = `10`,
|  | int32 | maxY = `10`,
|  | const String & | sectionName = `StringUtil::BLANK` |
| ) |  |  |

Create a TerrainPagedWorldSection.

Remarks:
  This is the simplest way to create a world section which is configured to contain terrain (among other objects if you want). You can also do this by calling PagedWorld::createSection with the type "Terrain" but there are more steps to configuring it that way (note: this is how loading works though so it remains generic).

Parameters:

  | world | The PagedWorld that is to contain this section
  | terrainGroup | A TerrainGroup which must have been pre-configured before this call, to at least set the origin, the world size, and the file name convention.
  | loadRadius | The radius from the camera at which terrain pages will be loaded
  | holdRadius | The radius from the camera at which terrain pages will be held in memory but not loaded if they're not already. This must be larger than loadRadius and is used to minimise thrashing if the camera goes backwards and forwards at the loading border.
  | minX,minY,maxX,maxY | The min/max page indexes that the world will try to load pages for, as measured from the origin page at (0,0) by a signed index. The default is -10 to 10 in each direction or 20x20 pages.
  | sectionName | An optional name to give the section (if none is provided, one will be generated)

Returns:
  The world section which is already attached to and owned by the world you passed in. There is no 'destroy' method because you destroy via the PagedWorld, this is just a helper function.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | void * |  |
| ) |  |  | `[inherited]`

Definition at line 101 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |  |
| ) |  |  | `[inherited]`

Definition at line 107 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr | ) | `[inherited]`

Definition at line 95 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |  |
| ) |  |  | `[inherited]`

Definition at line 118 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr | ) | `[inherited]`

Definition at line 112 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz | ) | `[inherited]`

Definition at line 72 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | void * | ptr |
| ) |  |  | `[inherited]`

placement operator new

Definition at line 78 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func |
| ) |  |  | `[inherited]`

operator new, with debug line info

Definition at line 67 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz | ) | `[inherited]`

Definition at line 90 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func |
| ) |  |  | `[inherited]`

array operator new, with debug line info

Definition at line 85 of file OgreMemoryAllocatedObject.h.

## Member Data Documentation

PageManager* Ogre::TerrainPaging::mManager`[protected]`

Definition at line 111 of file OgreTerrainPaging.h.

SectionFactory Ogre::TerrainPaging::mSectionFactory`[protected]`

Definition at line 123 of file OgreTerrainPaging.h.

The documentation for this class was generated from the following file:

- OgreTerrainPaging.h

Copyright © 2008 Torus Knot Software Ltd
This work is licensed under a Creative Commons Attribution-ShareAlike 3.0 Unported License.
Last modified Wed Nov 3 2010 19:25:05